# bitset Class Template Reference
[Containers]

List of all members.

## Detailed Description

### template<size_t _Nb>
class std::bitset< _Nb >

(Note that bitset does not meet the formal requirements of a container. Mainly, it lacks iterators.)

The template argument, Nb, may be any non-negative number, specifying the number of bits (e.g., "0", "12", "1024*1024").

In the general unoptimized case, storage is allocated in word-sized blocks. Let B be the number of bits in a word, then (Nb+(B-1))/B words will be used for storage. B - NbB bits are unused. (They are the high-order bits in the highest word.) It is a class invariant that those unused bits are always zero.

If you think of bitset as "a simple array of bits," be aware that your mental picture is reversed: a bitset behaves the same way as bits in integers do, with the bit at index 0 in the "least significant / right-hand" position, and the bit at index Nb-1 in the "most significant / left-hand" position. Thus, unlike other containers, a bitset's index "counts from right to left," to put it very loosely.

This behavior is preserved when translating to and from strings. For example, the first line of the following program probably prints "b('a') is 0001100001" on a modern ASCII system.

         #include <bitset>
         #include <iostream>
         #include <sstream>

         using namespace std;

         int main()
         {
             long         a = 'a';
             bitset<10>   b(a);

             cout << "b('a') is " << b << endl;

             ostringstream s;
             s << b;
             string  str = s.str();
             cout << "index 3 in the string is " << str[3] << " but\n"
                  << "index 3 in the bitset is " << b[3] << endl;
         }

Also see http://gcc.gnu.org/onlinedocs/libstdc++/ext/sgiexts.html#ch23 for a description of extensions.

Definition at line 645 of file bitset.

## Public Member Functions

- size_t _Find_first () const
- size_t _Find_next (size_t __prev) const
- template<class _CharT, class _Traits, class _Alloc> void _M_copy_from_string (const basic_string< _CharT, _Traits, _Alloc > &__s, size_t, size_t)
- template<class _CharT, class _Traits, class _Alloc> void _M_copy_to_string (basic_string< _CharT, _Traits, _Alloc > &) const
- bitset< _Nb > & _Unchecked_flip (size_t __pos)
- bitset< _Nb > & _Unchecked_reset (size_t __pos)
- bitset< _Nb > & _Unchecked_set (size_t __pos, int __val)
- bitset< _Nb > & _Unchecked_set (size_t __pos)
- bool _Unchecked_test (size_t __pos) const
- bool any () const
- template<class _CharT, class _Traits, class _Alloc> bitset (const basic_string< _CharT, _Traits, _Alloc > &__s, size_t __position, size_t __n)
- template<class _CharT, class _Traits, class _Alloc> bitset (const basic_string< _CharT, _Traits, _Alloc > &__s, size_t __position=0)
- bitset (unsigned long __val)
- bitset ()
- size_t count () const
- bitset< _Nb > & flip (size_t __position)
- bitset< _Nb > & flip ()
- bool none () const
- bitset< _Nb > & operator &= (const bitset< _Nb > &__rhs)
- bool operator!= (const bitset< _Nb > &__rhs) const
- bitset< _Nb > operator<< (size_t __position) const
- bitset< _Nb > & operator<<= (size_t __position)
- bool operator== (const bitset< _Nb > &__rhs) const
- bitset< _Nb > operator>> (size_t __position) const
- bitset< _Nb > & operator>>= (size_t __position)
- bool operator[] (size_t __position) const
- reference operator[] (size_t __position)
- bitset< _Nb > & operator^= (const bitset< _Nb > &__rhs)
- bitset< _Nb > & operator|= (const bitset< _Nb > &__rhs)
- bitset< _Nb > operator~ () const
- bitset< _Nb > & reset (size_t __position)
- bitset< _Nb > & reset ()
- bitset< _Nb > & set (size_t __position, bool __val=true)
- bitset< _Nb > & set ()
- size_t size () const
- bool test (size_t __position) const
- basic_string< char, char_traits<
  char >, allocator< char > > to_string () const
- template<class _CharT> basic_string< _CharT, char_traits<
  _CharT >, allocator< _CharT > > to_string () const
- template<class _CharT, class _Traits> basic_string< _CharT, _Traits,
  allocator< _CharT > > to_string () const
- template<class _CharT, class _Traits, class _Alloc> basic_string< _CharT, _Traits,
  _Alloc > to_string () const
- unsigned long to_ulong () const

## Friends

- class reference

## Classes

- class reference

## Constructor & Destructor Documentation

bitset | ( |  | ) | `[inline]`

| All bits set to zero. Definition at line 735 of file bitset.

bitset | ( | unsigned long | __val | ) | `[inline]`

| Initial bits bitwise-copied from a single word (others set to zero). Definition at line 739 of file bitset.

bitset | ( | const basic_string< _CharT, _Traits, _Alloc > & | __s,
|  | size_t | __position = `0`
| ) | `[inline, explicit]`

Use a subset of a string.

Parameters:

  | s | A string of '0' and '1' characters.
  | position | Index of the first character in s to use; defaults to zero.

Exceptions:

  | std::out_of_range | If pos is bigger the size of s.
  | std::invalid_argument | If a character appears in the string which is neither '0' nor '1'.

Definition at line 754 of file bitset.

References basic_string::size().

bitset | ( | const basic_string< _CharT, _Traits, _Alloc > & | __s,
|  | size_t | __position,
|  | size_t | __n
| ) | `[inline]`

Use a subset of a string.

Parameters:

  | s | A string of '0' and '1' characters.
  | position | Index of the first character in s to use.
  | n | The number of characters to copy.

Exceptions:

  | std::out_of_range | If pos is bigger the size of s.
  | std::invalid_argument | If a character appears in the string which is neither '0' nor '1'.

Definition at line 775 of file bitset.

References basic_string::size().

## Member Function Documentation

bool any | ( |  | ) | const`[inline]`

Tests whether any of the bits are on.

Returns:
  True if at least one bit is set.

Definition at line 1091 of file bitset.

size_t count | ( |  | ) | const`[inline]`

| Returns the number of bits which are set. Definition at line 1053 of file bitset.

bitset<_Nb>& flip | ( | size_t | __position | ) | `[inline]`

Toggles a given bit to its opposite value.

Parameters:

  | position | The index of the bit.

Exceptions:

  | std::out_of_range | If pos is bigger the size of the set.

Definition at line 960 of file bitset.

bitset<_Nb>& flip | ( |  | ) | `[inline]`

| Toggles every bit to its opposite value. Definition at line 947 of file bitset.

bool none | ( |  | ) | const`[inline]`

Tests whether any of the bits are on.

Returns:
  True if none of the bits are set.

Definition at line 1099 of file bitset.

bitset<_Nb>& operator &= | ( | const bitset< _Nb > & | __rhs | ) | `[inline]`

Operations on bitsets.

Parameters:

  | rhs | A same-sized bitset.

These should be self-explanatory.

Definition at line 794 of file bitset.

bitset<_Nb> operator<< | ( | size_t | __position | ) | const`[inline]`

| Self-explanatory. Definition at line 1105 of file bitset.

bitset<_Nb>& operator<<= | ( | size_t | __position | ) | `[inline]`

Operations on bitsets.

Parameters:

  | position | The number of places to shift.

These should be self-explanatory.

Definition at line 823 of file bitset.

bool operator== | ( | const bitset< _Nb > & | __rhs | ) | const`[inline]`

| These comparisons for equality/inequality are, well, bitwise. Definition at line 1064 of file bitset.

reference operator[] | ( | size_t | __position | ) | `[inline]`

Array-indexing support.

Parameters:

  | position | Index into the bitset.

Returns:
  A bool for a 'const bitset'. For non-const bitsets, an instance of the reference proxy class.

Note:
  These operators do no range checking and throw no exceptions, as required by DR 11 to the standard.

Definition at line 990 of file bitset.

bitset<_Nb> operator~ | ( |  | ) | const`[inline]`

| See the no-argument flip(). Definition at line 969 of file bitset.

bitset<_Nb>& reset | ( | size_t | __position | ) | `[inline]`

Sets a given bit to false.

Parameters:

  | position | The index of the bit.

Exceptions:

  | std::out_of_range | If pos is bigger the size of the set.

Same as writing `set(pos,false)`.

Definition at line 936 of file bitset.

bitset<_Nb>& reset | ( |  | ) | `[inline]`

| Sets every bit to false. Definition at line 922 of file bitset.

bitset<_Nb>& set | ( | size_t | __position,
|  | bool | __val = `true`
| ) | `[inline]`

Sets a given bit to a particular value.

Parameters:

  | position | The index of the bit.
  | val | Either true or false, defaults to true.

Exceptions:

  | std::out_of_range | If pos is bigger the size of the set.

Definition at line 911 of file bitset.

bitset<_Nb>& set | ( |  | ) | `[inline]`

| Sets every bit to true. Definition at line 897 of file bitset.

size_t size | ( |  | ) | const`[inline]`

| Returns the total number of bits. Definition at line 1058 of file bitset.

bool test | ( | size_t | __position | ) | const`[inline]`

Tests the value of a bit.

Parameters:

  | position | The index of a bit.

Returns:
  The value at pos.

Exceptions:

  | std::out_of_range | If pos is bigger the size of the set.

Definition at line 1079 of file bitset.

basic_string<_CharT, _Traits, _Alloc> to_string | ( |  | ) | const`[inline]`

Retuns a character interpretation of the bitset.

Returns:
  The string equivalent of the bits.

Note the ordering of the bits: decreasing character positions correspond to increasing bit positions (see the main class notes for an example).

Definition at line 1018 of file bitset.

unsigned long to_ulong | ( |  | ) | const`[inline]`

Retuns a numerical interpretation of the bitset.

Returns:
  The integral equivalent of the bits.

Exceptions:

  | std::overflow_error | If there are too many bits to be represented in an `unsigned` `long`.

Definition at line 1005 of file bitset.

The documentation for this class was generated from the following file:

- bitset